import { defineComponent, openBlock, createElementBlock, createElementVNode, normalizeStyle, toDisplayString, renderSlot } from 'vue';

var script = /*#__PURE__*/defineComponent({
  name: 'VueModal',
  props: {
    title: {
      type: String,
      default: 'Modal'
    },
    width: {
      type: String,
      default: '80%'
    }
  },

  data() {
    return {};
  },

  methods: {
    closeModal() {
      let element = document.querySelector(".modal-parent");
      element.classList.remove('modal-open');
      element.classList.add('modal-close');
    },

    openModal() {
      let element = document.querySelector(".modal-parent");
      element.addEventListener("click", e => {
        if (e.target.classList[0] == 'modal-parent') {
          e.target.classList.add('modal-close');
        }

        e.stopPropagation();
      }, false);
      element.classList.remove('modal-close');
      element.classList.add('modal-open');
      let elements = document.querySelector('.modal-form-01').getElementsByClassName('keyboard-accessible');

      if (elements.length > 0) {
        elements[0].focus();
        elements[0].addEventListener("keydown", e => {
          if (e.shiftKey && e.key == 'Tab') {
            e.preventDefault();
          }
        });
        elements[elements.length - 1].addEventListener("keydown", e => {
          if (e.key == 'Tab') {
            e.preventDefault();
            document.querySelector('.modal-close-01').focus();
            document.querySelector('.modal-close-01').addEventListener("keydown", e2 => {
              if (e2.shiftKey && e2.key == 'Tab') {
                e2.preventDefault();
              }
            });
          }
        });
      } else {
        document.querySelector('.modal-close-01').addEventListener("keydown", e2 => {
          if (e2.shiftKey && e2.key == 'Tab') {
            e2.preventDefault();
          } else if (e2.key == 'Tab') {
            e2.preventDefault();
          }
        });
      }
    }

  }
});

const _hoisted_1 = {
  class: "modal-parent modal-close"
};
const _hoisted_2 = {
  class: "modal-top"
};
const _hoisted_3 = {
  class: "heading"
};
const _hoisted_4 = {
  class: "modal-form-01"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1, [createElementVNode("div", {
    style: normalizeStyle({
      width: _ctx.width
    }),
    class: "modal-body"
  }, [createElementVNode("div", _hoisted_2, [createElementVNode("span", _hoisted_3, toDisplayString(_ctx.title), 1), createElementVNode("button", {
    onClick: _cache[0] || (_cache[0] = $event => _ctx.closeModal()),
    "aria-label": "close",
    class: "modal-close-01"
  }, "×")]), createElementVNode("div", _hoisted_4, [renderSlot(_ctx.$slots, "default")])], 4)]);
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "\n.modal-parent[data-v-21aad720] {\n  position: fixed; \n  z-index: 1; \n  padding-top: 100px; \n  left: 0;\n  top: 0;\n  width: 100%; \n  height: 100%; \n  overflow: auto;\n  background-color: rgb(0,0,0); \n  background-color: rgba(0,0,0,0.4);\n}\n.modal-open[data-v-21aad720]{\n  display: block;\n}\n.modal-close[data-v-21aad720]{\n  display: none;\n}\n.modal-parent .modal-body[data-v-21aad720] {\n  background-color: #fefefe;\n  margin: auto;\n  padding: 20px;\n  border: 1px solid #888;\n}\n.modal-parent .modal-body .modal-form-01[data-v-21aad720]{\n  margin-top: 50px;\n}\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720] {\n  color: #d34fff;\n  font-size: 20px;\n  font-weight: bold;\n  text-decoration: none;\n  background: #ffffff;\n  padding: 2px 8px;\n  border-radius: 40px;\n  border: 3px solid #d34fff;\n  float: right;\n}\n.modal-parent .modal-body .modal-top .heading[data-v-21aad720] {\n  color: #aaaaaa;\n  float: left;\n  font-size: 28px;\n  font-weight: bold;\n}\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720]:hover,\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720]:focus {\n  color: #9a0bc9;\n  text-decoration: none;\n  cursor: pointer;\n  transition: 0.5s;\n}\n\n";
styleInject(css_248z);

script.render = render;
script.__scopeId = "data-v-21aad720";

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = script; // Attach install function executed by Vue.use()

  installable.install = app => {
    app.component('Testxyz', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export { entry_esm as default };
