'use strict';var vue=require('vue');function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}var script = /*#__PURE__*/vue.defineComponent({
  name: 'VueModal',
  props: {
    title: {
      type: String,
      default: 'Modal'
    },
    width: {
      type: String,
      default: '80%'
    }
  },
  data: function data() {
    return {};
  },
  methods: {
    closeModal: function closeModal() {
      var element = document.querySelector(".modal-parent");
      element.classList.remove('modal-open');
      element.classList.add('modal-close');
    },
    openModal: function openModal() {
      var element = document.querySelector(".modal-parent");
      element.addEventListener("click", function (e) {
        if (e.target.classList[0] == 'modal-parent') {
          e.target.classList.add('modal-close');
        }

        e.stopPropagation();
      }, false);
      element.classList.remove('modal-close');
      element.classList.add('modal-open');
      var elements = document.querySelector('.modal-form-01').getElementsByClassName('keyboard-accessible');

      if (elements.length > 0) {
        elements[0].focus();
        elements[0].addEventListener("keydown", function (e) {
          if (e.shiftKey && e.key == 'Tab') {
            e.preventDefault();
          }
        });
        elements[elements.length - 1].addEventListener("keydown", function (e) {
          if (e.key == 'Tab') {
            e.preventDefault();
            document.querySelector('.modal-close-01').focus();
            document.querySelector('.modal-close-01').addEventListener("keydown", function (e2) {
              if (e2.shiftKey && e2.key == 'Tab') {
                e2.preventDefault();
              }
            });
          }
        });
      } else {
        document.querySelector('.modal-close-01').addEventListener("keydown", function (e2) {
          if (e2.shiftKey && e2.key == 'Tab') {
            e2.preventDefault();
          } else if (e2.key == 'Tab') {
            e2.preventDefault();
          }
        });
      }
    }
  }
});var _hoisted_1 = {
  class: "modal-parent modal-close"
};
var _hoisted_2 = {
  class: "modal-top"
};
var _hoisted_3 = {
  class: "heading"
};
var _hoisted_4 = {
  class: "modal-form-01"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return vue.openBlock(), vue.createElementBlock("div", _hoisted_1, [vue.createElementVNode("div", {
    style: vue.normalizeStyle({
      width: _ctx.width
    }),
    class: "modal-body"
  }, [vue.createElementVNode("div", _hoisted_2, [vue.createElementVNode("span", _hoisted_3, vue.toDisplayString(_ctx.title), 1), vue.createElementVNode("button", {
    onClick: _cache[0] || (_cache[0] = function ($event) {
      return _ctx.closeModal();
    }),
    "aria-label": "close",
    class: "modal-close-01"
  }, "×")]), vue.createElementVNode("div", _hoisted_4, [vue.renderSlot(_ctx.$slots, "default")])], 4)]);
}function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}var css_248z = "\n.modal-parent[data-v-21aad720] {\n  position: fixed; \n  z-index: 1; \n  padding-top: 100px; \n  left: 0;\n  top: 0;\n  width: 100%; \n  height: 100%; \n  overflow: auto;\n  background-color: rgb(0,0,0); \n  background-color: rgba(0,0,0,0.4);\n}\n.modal-open[data-v-21aad720]{\n  display: block;\n}\n.modal-close[data-v-21aad720]{\n  display: none;\n}\n.modal-parent .modal-body[data-v-21aad720] {\n  background-color: #fefefe;\n  margin: auto;\n  padding: 20px;\n  border: 1px solid #888;\n}\n.modal-parent .modal-body .modal-form-01[data-v-21aad720]{\n  margin-top: 50px;\n}\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720] {\n  color: #d34fff;\n  font-size: 20px;\n  font-weight: bold;\n  text-decoration: none;\n  background: #ffffff;\n  padding: 2px 8px;\n  border-radius: 40px;\n  border: 3px solid #d34fff;\n  float: right;\n}\n.modal-parent .modal-body .modal-top .heading[data-v-21aad720] {\n  color: #aaaaaa;\n  float: left;\n  font-size: 28px;\n  font-weight: bold;\n}\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720]:hover,\n.modal-parent .modal-body .modal-top .modal-close-01[data-v-21aad720]:focus {\n  color: #9a0bc9;\n  text-decoration: none;\n  cursor: pointer;\n  transition: 0.5s;\n}\n\n";
styleInject(css_248z);script.render = render;
script.__scopeId = "data-v-21aad720";// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var component = /*#__PURE__*/(function () {
  // Get component instance
  var installable = script; // Attach install function executed by Vue.use()

  installable.install = function (app) {
    app.component('Testxyz', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default':component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;